select
    an.numero
    , idade.anos || ' ano(s) ' || idade.meses || ' ms(s) ' || idade.dias || ' dia(s)' Ideade
    , (select grausangue from sp_calculagrausangue (an.cdanimal)) as Grau_sangue
    , (select count(*) from animal where cdmae = an.cdanimal) as Num_Crias
    , (case
        when par01.cdreproducao is not null then (((par10.data - par09.data)+(par09.data - par08.data)+(par08.data - par07.data)+(par07.data - par06.data)+(par06.data - par05.data)+(par05.data - par04.data)+(par04.data - par03.data)+(par03.data - par02.data)+(par02.data - par01.data))/9)
        when par02.cdreproducao is not null then (((par10.data - par09.data)+(par09.data - par08.data)+(par08.data - par07.data)+(par07.data - par06.data)+(par06.data - par05.data)+(par05.data - par04.data)+(par04.data - par03.data)+(par03.data - par02.data))/8)
        when par03.cdreproducao is not null then (((par10.data - par09.data)+(par09.data - par08.data)+(par08.data - par07.data)+(par07.data - par06.data)+(par06.data - par05.data)+(par05.data - par04.data)+(par04.data - par03.data))/7)
        when par04.cdreproducao is not null then (((par10.data - par09.data)+(par09.data - par08.data)+(par08.data - par07.data)+(par07.data - par06.data)+(par06.data - par05.data)+(par05.data - par04.data))/6)
        when par05.cdreproducao is not null then (((par10.data - par09.data)+(par09.data - par08.data)+(par08.data - par07.data)+(par07.data - par06.data)+(par06.data - par05.data))/5)
        when par06.cdreproducao is not null then (((par10.data - par09.data)+(par09.data - par08.data)+(par08.data - par07.data)+(par07.data - par06.data))/4)
        when par07.cdreproducao is not null then (((par10.data - par09.data)+(par09.data - par08.data)+(par08.data - par07.data))/3)
        when par08.cdreproducao is not null then (((par10.data - par09.data)+(par09.data - par08.data))/2)
        when par09.cdreproducao is not null then (((par10.data - par09.data))/1)
        else null end) as Media_entre_partos
    , (par10.data - par09.data) as Ult_Intervalo_Entre_Partos
--------------------------------------------------------------------------------
    , c10.numero as numero_cria_1
    , c10.sexo as sexo_cria_1
    , (select grausangue from sp_calculagrausangue (c10.cdanimal)) as Grau_sangue_cria_1
    , c10.dtdesmama as Desmama_cria_1
    , (select first 1 p.peso from peso p where p.cdanimal = c10.cdanimal and p.dtpeso = c10.dtdesmama) as pes_desmama_cria_1
    , id10.anos || ' ano(s) ' || id10.meses || ' ms(s) ' || id10.dias || ' dia(s)' Ideade_desmama_cria_1

    , c09.numero as numero_cria_2
    , c09.sexo as sexo_cria_2
    , (select grausangue from sp_calculagrausangue (c09.cdanimal)) as Grau_sangue_cria_2
    , c09.dtdesmama as Desmama_cria_2
    , (select first 1 p.peso from peso p where p.cdanimal = c09.cdanimal and p.dtpeso = c09.dtdesmama) as pes_desmama_cria_2
    , id09.anos || ' ano(s) ' || id09.meses || ' ms(s) ' || id09.dias || ' dia(s)' Ideade_desmama_cria_2

    , c08.numero as numero_cria_3
    , c08.sexo as sexo_cria_3
    , (select grausangue from sp_calculagrausangue (c08.cdanimal)) as Grau_sangue_cria_3
    , c08.dtdesmama as Desmama_cria_3
    , (select first 1 p.peso from peso p where p.cdanimal = c08.cdanimal and p.dtpeso = c08.dtdesmama) as pes_desmama_cria_3
    , id08.anos || ' ano(s) ' || id08.meses || ' ms(s) ' || id08.dias || ' dia(s)' Ideade_desmama_cria_3

    , c07.numero as numero_cria_4
    , c07.sexo as sexo_cria_4
    , (select grausangue from sp_calculagrausangue (c07.cdanimal)) as Grau_sangue_cria_4
    , c07.dtdesmama as Desmama_cria_4
    , (select first 1 p.peso from peso p where p.cdanimal = c07.cdanimal and p.dtpeso = c07.dtdesmama) as pes_desmama_cria_4
    , id07.anos || ' ano(s) ' || id07.meses || ' ms(s) ' || id07.dias || ' dia(s)' Ideade_desmama_cria_4

    , c06.numero as numero_cria_5
    , c06.sexo as sexo_cria_5
    , (select grausangue from sp_calculagrausangue (c06.cdanimal)) as Grau_sangue_cria_5
    , c06.dtdesmama as Desmama_cria_5
    , (select first 1 p.peso from peso p where p.cdanimal = c06.cdanimal and p.dtpeso = c06.dtdesmama) as pes_desmama_cria_5
    , id06.anos || ' ano(s) ' || id06.meses || ' ms(s) ' || id06.dias || ' dia(s)' Ideade_desmama_cria_5

    , c05.numero as numero_cria_6
    , c05.sexo as sexo_cria_6
    , (select grausangue from sp_calculagrausangue (c05.cdanimal)) as Grau_sangue_cria_6
    , c05.dtdesmama as Desmama_cria_6
    , (select first 1 p.peso from peso p where p.cdanimal = c05.cdanimal and p.dtpeso = c05.dtdesmama) as pes_desmama_cria_6
    , id05.anos || ' ano(s) ' || id05.meses || ' ms(s) ' || id05.dias || ' dia(s)' Ideade_desmama_cria_6

    , c04.numero as numero_cria_7
    , c04.sexo as sexo_cria_7
    , (select grausangue from sp_calculagrausangue (c04.cdanimal)) as Grau_sangue_cria_7
    , c04.dtdesmama as Desmama_cria_7
    , (select first 1 p.peso from peso p where p.cdanimal = c04.cdanimal and p.dtpeso = c04.dtdesmama) as pes_desmama_cria_7
    , id04.anos || ' ano(s) ' || id04.meses || ' ms(s) ' || id04.dias || ' dia(s)' Ideade_desmama_cria_7

    , c03.numero as numero_cria_8
    , c03.sexo as sexo_cria_8
    , (select grausangue from sp_calculagrausangue (c03.cdanimal)) as Grau_sangue_cria_8
    , c03.dtdesmama as Desmama_cria_8
    , (select first 1 p.peso from peso p where p.cdanimal = c03.cdanimal and p.dtpeso = c03.dtdesmama) as pes_desmama_cria_8
    , id03.anos || ' ano(s) ' || id03.meses || ' ms(s) ' || id03.dias || ' dia(s)' Ideade_desmama_cria_8

    , c02.numero as numero_cria_9
    , c02.sexo as sexo_cria_9
    , (select grausangue from sp_calculagrausangue (c02.cdanimal)) as Grau_sangue_cria_9
    , c02.dtdesmama as Desmama_cria_9
    , (select first 1 p.peso from peso p where p.cdanimal = c02.cdanimal and p.dtpeso = c02.dtdesmama) as pes_desmama_cria_9
    , id02.anos || ' ano(s) ' || id02.meses || ' ms(s) ' || id02.dias || ' dia(s)' Ideade_desmama_cria_9

    , c01.numero as numero_cria_10
    , c01.sexo as sexo_cria_10
    , (select grausangue from sp_calculagrausangue (c01.cdanimal)) as Grau_sangue_cria_10
    , c01.dtdesmama as Desmama_cria_10
    , (select first 1 p.peso from peso p where p.cdanimal = c01.cdanimal and p.dtpeso = c01.dtdesmama) as pes_desmama_cria_10
    , id01.anos || ' ano(s) ' || id01.meses || ' ms(s) ' || id01.dias || ' dia(s)' Ideade_desmama_cria_10

from animal an
    left join sp_idadeanimal('PERMANENCIA', 'WHERE CDANIMAL = ' || AN.CDANIMAL) idade on 1=1
    left join reproducao par10 on par10.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = an.cdanimal
                and re.cdtiporeproducao = 7
            order by re.data desc)
    left join reproducao par09 on par09.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = an.cdanimal
                and re.cdtiporeproducao = 7
                and re.data < par10.data
            order by re.data desc)
    left join reproducao par08 on par08.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = an.cdanimal
                and re.cdtiporeproducao = 7
                and re.data < par09.data
            order by re.data desc)
    left join reproducao par07 on par07.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = an.cdanimal
                and re.cdtiporeproducao = 7
                and re.data < par08.data
            order by re.data desc)
    left join reproducao par06 on par06.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = an.cdanimal
                and re.cdtiporeproducao = 7
                and re.data < par07.data
            order by re.data desc)
    left join reproducao par05 on par05.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = an.cdanimal
                and re.cdtiporeproducao = 7
                and re.data < par06.data
            order by re.data desc)
    left join reproducao par04 on par04.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = an.cdanimal
                and re.cdtiporeproducao = 7
                and re.data < par05.data
            order by re.data desc)
    left join reproducao par03 on par03.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = an.cdanimal
                and re.cdtiporeproducao = 7
                and re.data < par04.data
            order by re.data desc)
    left join reproducao par02 on par02.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = an.cdanimal
                and re.cdtiporeproducao = 7
                and re.data < par03.data
            order by re.data desc)
    left join reproducao par01 on par01.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = an.cdanimal
                and re.cdtiporeproducao = 7
                and re.data < par02.data
            order by re.data desc)
--------------------------------------------------------------------------------
    left join animal c10 on c10.cdanimal =
        (select first 1 re1.cdanimal
            from animal re1
            where re1.cdmae = an.cdanimal
            order by re1.dtnascimento asc)

    left join animal c09 on c09.cdanimal =
        (select first 1 re1.cdanimal
            from animal re1
            where re1.cdmae = an.cdanimal
                and re1.dtnascimento >= c10.dtnascimento
                                                                                                                                and re1.cdanimal not in (c10.cdanimal)
            order by re1.dtnascimento asc)

    left join animal c08 on c08.cdanimal =
        (select first 1 re1.cdanimal
            from animal re1
            where re1.cdmae = an.cdanimal
                and re1.dtnascimento >= c09.dtnascimento
                                                                                                                                and re1.cdanimal not in (c10.cdanimal, c09.cdanimal)
            order by re1.dtnascimento asc)

    left join animal c07 on c07.cdanimal =
        (select first 1 re1.cdanimal
            from animal re1
            where re1.cdmae = an.cdanimal
                and re1.dtnascimento >= c08.dtnascimento
                                                                                                                                and re1.cdanimal not in (c10.cdanimal, c09.cdanimal, c08.cdanimal)
            order by re1.dtnascimento asc)

    left join animal c06 on c06.cdanimal =
        (select first 1 re1.cdanimal
            from animal re1
            where re1.cdmae = an.cdanimal
                and re1.dtnascimento >= c07.dtnascimento
                                                                                                                                and re1.cdanimal not in (c10.cdanimal, c09.cdanimal, c08.cdanimal, c07.cdanimal)
            order by re1.dtnascimento asc)

    left join animal c05 on c05.cdanimal =
        (select first 1 re1.cdanimal
            from animal re1
            where re1.cdmae = an.cdanimal
                and re1.dtnascimento >= c06.dtnascimento
                                                                                                                                and re1.cdanimal not in (c10.cdanimal, c09.cdanimal, c08.cdanimal, c07.cdanimal, c06.cdanimal)
            order by re1.dtnascimento asc)

    left join animal c04 on c04.cdanimal =
        (select first 1 re1.cdanimal
            from animal re1
            where re1.cdmae = an.cdanimal
                and re1.dtnascimento >= c05.dtnascimento
                                                                                                                                and re1.cdanimal not in (c10.cdanimal, c09.cdanimal, c08.cdanimal, c07.cdanimal, c06.cdanimal, c05.cdanimal)
            order by re1.dtnascimento asc)

    left join animal c03 on c03.cdanimal =
        (select first 1 re1.cdanimal
            from animal re1
            where re1.cdmae = an.cdanimal
                and re1.dtnascimento >= c04.dtnascimento
                                                                                                                                and re1.cdanimal not in (c10.cdanimal, c09.cdanimal, c08.cdanimal, c07.cdanimal, c06.cdanimal, c05.cdanimal, c04.cdanimal)
            order by re1.dtnascimento asc)

    left join animal c02 on c02.cdanimal =
        (select first 1 re1.cdanimal
            from animal re1
            where re1.cdmae = an.cdanimal
                and re1.dtnascimento >= c03.dtnascimento
                                                                                                                                and re1.cdanimal not in (c10.cdanimal, c09.cdanimal, c08.cdanimal, c07.cdanimal, c06.cdanimal, c05.cdanimal, c04.cdanimal, c03.cdanimal)
            order by re1.dtnascimento asc)

    left join animal c01 on c01.cdanimal =
        (select first 1 re1.cdanimal
            from animal re1
            where re1.cdmae = an.cdanimal
                and re1.dtnascimento >= c02.dtnascimento
                                                                                                                                and re1.cdanimal not in (c10.cdanimal, c09.cdanimal, c08.cdanimal, c07.cdanimal, c06.cdanimal, c05.cdanimal, c04.cdanimal, c03.cdanimal, c02.cdanimal)
            order by re1.dtnascimento asc)
--------------------------------------------------------------------------------
    left join sp_idadeanimal('PERMANENCIA', 'WHERE CDANIMAL = ' || coalesce(C10.CDANIMAL, '-1')) id10 on 1=1
    left join sp_idadeanimal('PERMANENCIA', 'WHERE CDANIMAL = ' || coalesce(C09.CDANIMAL, '-1')) id09 on 1=1
    left join sp_idadeanimal('PERMANENCIA', 'WHERE CDANIMAL = ' || coalesce(C08.CDANIMAL, '-1')) id08 on 1=1
    left join sp_idadeanimal('PERMANENCIA', 'WHERE CDANIMAL = ' || coalesce(C07.CDANIMAL, '-1')) id07 on 1=1
    left join sp_idadeanimal('PERMANENCIA', 'WHERE CDANIMAL = ' || coalesce(C06.CDANIMAL, '-1')) id06 on 1=1
    left join sp_idadeanimal('PERMANENCIA', 'WHERE CDANIMAL = ' || coalesce(C05.CDANIMAL, '-1')) id05 on 1=1
    left join sp_idadeanimal('PERMANENCIA', 'WHERE CDANIMAL = ' || coalesce(C04.CDANIMAL, '-1')) id04 on 1=1
    left join sp_idadeanimal('PERMANENCIA', 'WHERE CDANIMAL = ' || coalesce(C03.CDANIMAL, '-1')) id03 on 1=1
    left join sp_idadeanimal('PERMANENCIA', 'WHERE CDANIMAL = ' || coalesce(C02.CDANIMAL, '-1')) id02 on 1=1
    left join sp_idadeanimal('PERMANENCIA', 'WHERE CDANIMAL = ' || coalesce(C01.CDANIMAL, '-1')) id01 on 1=1

where
    an.tipoanimal = 'A'
    and an.sexo = 'F'
    and an.animalrebanho = 1
-- Somente as vacas
    and an.cdcategoria = 7
order by an.numordenado


